For a complete page index, fetch https://developer.close.com/llms.txt

# Create new Custom Activity Type

POST https://api.close.com/api/v1/custom_activity/
Content-Type: application/json

The type must be created before activity custom fields can be added.

Reference: https://developer.close.com/api/resources/custom-activity-types/create

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Close API
  version: 1.0.0
paths:
  /custom_activity/:
    post:
      operationId: create
      summary: Create new Custom Activity Type
      description: The type must be created before activity custom fields can be added.
      tags:
        - subpackage_customActivityTypes
      parameters:
        - name: Authorization
          in: header
          description: Basic authentication
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/custom_activity_types_create_Response_201'
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                description: Any type
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                description: Any type
        '404':
          description: Not found
          content:
            application/json:
              schema:
                description: Any type
      requestBody:
        content:
          application/json:
            schema:
              description: Any type
servers:
  - url: https://api.close.com/api/v1
components:
  schemas:
    custom_activity_types_create_Response_201:
      type: object
      properties: {}
      description: Empty response body
      title: custom_activity_types_create_Response_201
  securitySchemes:
    ApiKeyAuth:
      type: http
      scheme: basic
    OAuth2:
      type: http
      scheme: bearer

```

## SDK Code Examples

```python
import requests

url = "https://api.close.com/api/v1/custom_activity/"

payload = {
    "api_create_only": False,
    "description": "Lead requested a product demo.",
    "editable_with_roles": ["admin"],
    "name": "Demo Requested"
}
headers = {
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers, auth=("<CLOSE_API_KEY>", ""))

print(response.json())
```

```javascript
const url = 'https://api.close.com/api/v1/custom_activity/';
const credentials = btoa("<CLOSE_API_KEY>:");

const options = {
  method: 'POST',
  headers: {Authorization: `Basic ${credentials}`, 'Content-Type': 'application/json'},
  body: '{"api_create_only":false,"description":"Lead requested a product demo.","editable_with_roles":["admin"],"name":"Demo Requested"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.close.com/api/v1/custom_activity/"

	payload := strings.NewReader("{\n  \"api_create_only\": false,\n  \"description\": \"Lead requested a product demo.\",\n  \"editable_with_roles\": [\n    \"admin\"\n  ],\n  \"name\": \"Demo Requested\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.SetBasicAuth("<CLOSE_API_KEY>", "")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.close.com/api/v1/custom_activity/")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request.basic_auth("<CLOSE_API_KEY>", "")
request["Content-Type"] = 'application/json'
request.body = "{\n  \"api_create_only\": false,\n  \"description\": \"Lead requested a product demo.\",\n  \"editable_with_roles\": [\n    \"admin\"\n  ],\n  \"name\": \"Demo Requested\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.close.com/api/v1/custom_activity/")
  .basicAuth("<CLOSE_API_KEY>", "")
  .header("Content-Type", "application/json")
  .body("{\n  \"api_create_only\": false,\n  \"description\": \"Lead requested a product demo.\",\n  \"editable_with_roles\": [\n    \"admin\"\n  ],\n  \"name\": \"Demo Requested\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.close.com/api/v1/custom_activity/', [
  'body' => '{
  "api_create_only": false,
  "description": "Lead requested a product demo.",
  "editable_with_roles": [
    "admin"
  ],
  "name": "Demo Requested"
}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
    'auth' => ['<CLOSE_API_KEY>', ''],
]);

echo $response->getBody();
```

```csharp
using RestSharp;
using RestSharp.Authenticators;

var client = new RestClient("https://api.close.com/api/v1/custom_activity/");
client.Authenticator = new HttpBasicAuthenticator("<CLOSE_API_KEY>", "");
var request = new RestRequest(Method.POST);

request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"api_create_only\": false,\n  \"description\": \"Lead requested a product demo.\",\n  \"editable_with_roles\": [\n    \"admin\"\n  ],\n  \"name\": \"Demo Requested\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```